#include <stdint.h>

typedef struct {
  int cmdId;
  unsigned char *bufp;
  unsigned int buflen;
  unsigned int chksum;
} CPU0Param;

typedef struct {
  int *p;
  int size;
} IntArray;

typedef struct {
  unsigned char *p;
  int size;
} ByteArray;

typedef struct {
  float *p;
  int size;
} FloatArray;

typedef struct {
  int size;
  unsigned char **p;
} StringArray;

#ifndef NULL
#define NULL		0
#endif 

#define TRUE 1
#define FALSE 0

#define RET_OK 0
#define RET_ERR 1

#define GPIO_PIN_NONE 0
#define TOTAL_USART_PORT 1

#define TOTAL_FIFO_PORT 1
#define FIFO0 0

#define TOTAL_SD_PORT 1
#define SD0 0

#define TOTAL_CDMA_PORT 1
#define CDMA0 0

#define SAMPLE_TYPE         float
typedef float               SAMPLE;

#define SAMPLES_PER_FRAME   2       // CD stereo
#define FRAMES_PER_BLOCK    64
#define NUM_BLOCKS          1024
#define NB_FRAMES           NUM_BLOCKS * FRAMES_PER_BLOCK

#define STANDARD_BUF_SIZE   NUM_BLOCKS * FRAMES_PER_BLOCK * SAMPLES_PER_FRAME * sizeof(SAMPLE)

#define SAMPLING_RATE 44100 
#define MAX_SAMPLE_RATE 44100
#define LOW_FREQ  10.0
#define HIGH_FREQ 20000.0

#define NUM_SAMPLES 22050
#define NUM_POINTS  1000  // max number of points for chart

#define LEFT_CHANNEL        0       // index
#define RIGHT_CHANNEL       1

#define LOG2 0.69314718055994530941723212145818

#define LOGSWEEP_SHORT 0
#define LOGSWEEP_FLOAT 1
#define INV_LOGSWEEP_SHORT 2
#define INV_LOGSWEEP_FLOAT 3

#define NB_SET 8
#define FPL  0
#define FPR  1
#define LPL  2
#define LPR  3
#define BPL  4
#define BPR  5
#define HPL  6
#define HPR  7

#define UINT8 uint8_t
#define UINT16 uint16_t
#define INT32 int32_t
#define UINT32 uint32_t
#define INT64 int64_t
#define UINT64 uint64_t

typedef unsigned char BOOL;
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef uint32 GPIO_PIN;
typedef void (*ISR_FN_t)(void);
typedef void (*HAL_CALLBACK_FPN)(void* arg);

#define global_interrupts_disable() __asm volatile("cpsid i")
#define global_interrupts_enable() __asm volatile("cpsie i") 

